import { runCleanup } from "../service";
import client from "./index";
import { initPromise } from "../data/dataSource";
import pushMonitor from "@astrogd/eu.astrogd.uptime-kuma-push-monitor";

const token = process.env["TOKEN"];
if (!token) throw new ReferenceError("TOKEN environment variable is missing");

async function run() {
    console.log("Establishing database connection");
    await initPromise;
    console.log("Connection established\nAuthenticating with Discord API");
    client.login(token);
}

client.on("ready", async () => {
    console.log(`Connected to Discord API. Bot account is ${client.user?.tag} (${client.user?.id})`);
    if (process.env["MONITOR_URL"]) pushMonitor.register(process.env["MONITOR_URL"], 120);
    pushMonitor.enableShutdownNotifications();
    pushMonitor.setPerformanceHandler(() => client.ws.ping);

    runCleanup();
});

run();